# Pokemonlib for python
[![Say Thanks!](https://img.shields.io/badge/Say%20Thanks-!-1EAEDB.svg)](https://saythanks.io/to/arthuro555)
[![Build Status](https://travis-ci.org/arthuro555/pokemonlib.svg?branch=master)](https://travis-ci.org/arthuro555/pokemonlib)
[![CircleCI](https://circleci.com/gh/arthuro555/pokemonlib/tree/master.svg?style=svg)](https://circleci.com/gh/arthuro555/pokemonlib/tree/master)

## WARNING:
**I Am not and don't claim to be affiliated with Pokemon or the Pokemon Company or Nintendo.
I do not own and don't claim to own Pokemon, the battle logic of the algorithm, the sprites,
the idea and the code of any official pokemon game. But I do own The code that is written by myself
and the way it was implemented.**

This is a library containing a WIP (Work In Progress) implementation of the pokemon battle algorithm and
other features of the pokemon games.

#### Present features:

* Automatically get base pokemon data from the PokeApi

#### WIP features
###### I mean what I'm actively working on (Checked if ready for release soon and currently in test)

- [ ] Pokemon Class
- [ ] Inventory/Player class
- [ ] Pokemon attacks
- [ ] Automatically get other pokemon data like sprites from the PokeApi
- [ ] Basic Battle UI (Very slow progress)
- [ ] Automatic game build

#### Planned Features:
###### (Checked means I'm starting to develop it as soon as I complete a WIP feature)

+ [X] Plugin System that permits to create your own pokemons/attacks/items
+ [X] Items (Needs Inventory first)
- [ ] Battle Logic (A class that handles the whole battle but without any UI)
- [ ] Overworld UI
- [ ] Trainers battle
- [ ] Possibility to catch pokemons
- [ ] Interaction system in Overworld

And possibly more ;-) you can always make a feature request in the issues tab.


## Python Compatibility

For now only python 3 is supported and python 2 support is not planned.
Anyways, if you're still using python 2, you should upgrade!

## Helping or contributing to the project

I have no problem with people helping me. If someone makes many good pull request I will consider to add them
as contributors of this repo. If someone contributes to the project by more than a few lines of code or do
something really useful (like some english teacher who fixes all the typos) I will add them to a credit section
and a file credits.txt.

**WARNING** I have some conditions for contributions.

1. Explain thoroughly what you changed/implemented, how and if it's not on my feature board on that file also why.
2. Don't ask me questions on the code I don't have much free time and I prefer to use them to code myself.
3. I probably won't document very much changes I do to the code and don't complain.
4. Unless I make someone a contributor, This will stay **_my_** project and any code pushed by someone else will be
considered as 'Donated' and will become mine. You accept by pushing anything here to give up on any copyright
or rights that you own on the code you added/modified. I don't want my project to be steeled.
5. I'm (With contributors if I add some) the one(s) that decide if someone should be added/removed from the credits.
I am not obligated to let someone who contributed to the project on the list if I judge that wasn't enough because
else the list could become too long and I don't want people's name that made real and good contributions to be
hidden by hundreds of names of people that changed 2 characters.
6. I'm the only one to decide if someone should be a contributor or not.
7. DON'T COMPLAIN ON ANYTHING. IF YOU MAKE A CONTRIBUTION IT'S YOUR CHOICE AND AS THIS CONDITIONS WERE HERE
SINCE THE FIRST COMMIT SO YOU KNEW THE CONDITIONS

### What this project is meant to become

This project is for now pieces of code on which you can use to make a simple pokemon game.
I want it to become a piece of software that you extend with your own script(s) and plugins.
A bit like renpy. If it goes on so far that all the 'Core' stuff is done and also the 'Graphical' part I would
want to make directly a 'Programming Language' for it (Just something to parse some pre defined syntax and connect it
with the 'Core' API) or a visual editor (Like idk Geometry dash). Keep the goal in mind if you make contributions
because if they are not compatible with my goals I will have to reject them.
